// D import file generated from 'src/objc/runtime.d'
module objc.runtime;
version (D_ObjC)
{
}
else
{
    static assert(0,"Compiler does not support the Objective-C object model");
}
import core.stdc.stdlib;
import core.stdc.stdint;
version (OSX)
{
    pragma (lib, "objc");
    version (PPC)
{
    version = LegacyRuntime;
    version = ModernAPI;
}
else
{
    version (X86)
{
    version = LegacyRuntime;
    version = ModernAPI;
}
else
{
    version (X86_64)
{
    version = ModernRuntime;
    version = ModernAPI;
}
else
{
    static assert(0,"Unsupported architecture");
}
}
}
}
else
{
    static assert(0,"Unsupported platform");
}
extern (C) 
{
    version (ModernAPI)
{
    const(char)* class_getName(Class cls);
    Class class_getSuperclass(Class cls);
    Class class_setSuperclass(Class cls, Class newSuper);
    BOOL class_isMetaClass(Class cls);
    size_t class_getInstanceSize(Class cls);
}
    Ivar class_getInstanceVariable(Class c, char* name);
    version (ModernAPI)
{
    Ivar class_getClassVariable(Class cls, const(char)* name);
    BOOL class_addIvar(Class cls, const(char)* name, size_t size, ubyte alignment, const(char)* types);
    Ivar* class_copyIvarList(Class cls, uint* outCount);
    const(char)* class_getIvarLayout(Class cls);
    void class_setIvarLayout(Class cls, const(char)* layout);
    const(char)* class_getWeakIvarLayout(Class cls);
    void class_setWeakIvarLayout(Class cls, const(char)* layout);
}
    version (ModernAPI)
{
    objc_property_t class_getProperty(Class cls, const(char)* name);
    objc_property_t* class_copyPropertyList(Class cls, uint* outCount);
}
    Method class_getInstanceMethod(Class aClass, SEL aSelector);
    Method class_getClassMethod(Class aClass, SEL aSelector);
    version (ModernAPI)
{
    BOOL class_addMethod(Class cls, SEL name, IMP imp, const(char)* types);
    Method* class_copyMethodList(Class cls, uint* outCount);
    IMP class_replaceMethod(Class cls, SEL name, IMP imp, const(char)* types);
    IMP class_getMethodImplementation(Class cls, SEL name);
    IMP class_getMethodImplementation_stret(Class cls, SEL name);
    BOOL class_respondsToSelector(Class cls, SEL sel);
}
    version (LegacyRuntime)
{
    objc_method_list* class_nextMethodList(Class c, void** iterator);
    void class_addMethods(Class c, objc_method_list* methodList);
    void class_removeMethods(Class c, objc_method_list* methodList);
}
    version (ModernAPI)
{
    BOOL class_addProtocol(Class cls, Protocol* protocol);
    BOOL class_conformsToProtocol(Class cls, Protocol* protocol);
    Protocol** class_copyProtocolList(Class cls, uint* outCount);
}
    void class_setVersion(Class c, int v);
    int class_getVersion(Class c);
    version (ModernAPI)
{
    Class objc_allocateClassPair(Class superclass, const(char)* name, size_t extraBytes);
    void objc_registerClassPair(Class cls);
    deprecated void objc_addClass(Class myClass);

}
    version (LegacyRuntime)
{
    void objc_addClass(Class myClass);
}
    version (LegacyRuntime)
{
    Class class_poseAs(Class imposter, Class original);
}
    id class_createInstance(Class c, uint additionalByteCount);
    version (LegacyRuntime)
{
    id class_createInstanceFromZone(Class c, uint additionalByteCount, void* zone);
}
    version (ModernAPI)
{
    id object_copy(id obj, size_t size);
    id object_dispose(id obj);
}
    Ivar object_setInstanceVariable(id obj, const(char)* name, void* value);
    Ivar object_getInstanceVariable(id obj, const(char)* name, void** value);
    version (ModernAPI)
{
    void* object_getIndexedIvars(id obj);
    id object_getIvar(id object, Ivar ivar);
    void object_setIvar(id object, Ivar ivar, id value);
    const(char)* object_getClassName(id obj);
    Class object_getClass(id object);
    Class object_setClass(id object, Class cls);
}
    int objc_getClassList(Class* buf, int len);
    Class objc_lookUpClass(const(char)* name);
    Class objc_getClass(const(char)* name);
    Class objc_getMetaClass(const(char)* name);
    version (ModernAPI)
{
    Class objc_getRequiredClass(const(char)* name);
}
    version (LegacyRuntime)
{
    void objc_setClassHandler(int function(const(char)*) callback);
}
    const(char)* ivar_getName(Ivar ivar);
    const(char)* ivar_getTypeEncoding(Ivar ivar);
    ptrdiff_t ivar_getOffset(Ivar ivar);
    version (ModernAPI)
{
    void objc_setAssociatedObject(id object, void* key, id value, objc_AssociationPolicy policy);
    id objc_getAssociatedObject(id object, void* key);
    void objc_removeAssociatedObjects(id object);
}
    id objc_msgSend(id receiver, SEL selector,...);
    void objc_msgSend_stret(void* structReturnPtr, id receiver, SEL selector,...);
    version (X86)
{
    double objc_msgSend_fpret(id receiver, SEL selector,...);
}
    id objc_msgSendSuper(objc_super* context, SEL selector,...);
    void objc_msgSendSuper_stret(void* structReturnPtr, objc_super* context, SEL selector,...);
    id objc_msgSendv(id receiver, SEL selector, uint argSize, marg_list argFrame);
    void objc_msgSendv_stret(void* stretAddr, id receiver, SEL selector, uint argSize, marg_list argFrame);
    version (X86)
{
    double objc_msgSendv_fpret(id receiver, SEL selector, uint argSize, marg_list argFrame);
}
}
version (LegacyRuntime)
{
    version (PPC)
{
    enum size_t marg_prearg_size = 128;
}
else
{
    version (X86)
{
    enum size_t marg_prearg_size = 0;
}
else
{
    static assert(0,"Unsupported architecture");
}
}
    void marg_malloc(out marg_list margs, Method method)
{
margs = cast(marg_list)malloc(marg_prearg_size + (7 + method_getSizeOfArguments(method) & ~7));
}
    void marg_free(marg_list margs)
{
free(margs);
}
    template marg_getRef(T)
{
T* marg_getRef(marg_list argList, size_t offset)
{
return cast(T*)(cast(byte*)margs + marg_prearg_size + offset);
}
}
    template marg_getValue(T)
{
T marg_getValue(marg_list argList, size_t offset)
{
return *marg_getRef(margs,offset);
}
}
    template marg_setValue(T)
{
void marg_setValue(marg_list argList, size_t offset, T value)
{
*marg_getRef(margs,offset) = value;
}
}
}
extern (C) 
{
    uint method_getNumberOfArguments(Method method);
    version (ModernAPI)
{
    SEL method_getName(Method method);
    IMP method_getImplementation(Method method);
    const(char)* method_getTypeEncoding(Method method);
    char* method_copyReturnType(Method method);
    char* method_copyArgumentType(Method method, uint index);
    void method_getReturnType(Method method, char* dst, size_t dst_len);
    void method_getArgumentType(Method method, uint index, char* dst, size_t dst_len);
    IMP method_setImplementation(Method method, IMP imp);
    void method_exchangeImplementations(Method m1, Method m2);
}
    version (LegacyRuntime)
{
    uint method_getSizeOfArguments(Method method);
    uint method_getArgumentInfo(Method method, int index, char** type, int* offset);
}
    const(char)* sel_getName(SEL aSelector);
    SEL sel_registerName(const char* str);
    SEL sel_getUid(const char* str);
    BOOL sel_isEqual(SEL lhs, SEL rhs);
    version (LegacyRuntime)
{
    BOOL sel_isMapped(SEL aSelector);
}
    typedef objc_object Protocol;
    version (ModernAPI)
{
    Protocol* objc_getProtocol(const(char)* name);
    Protocol** objc_copyProtocolList(uint* outCount);
    const(char)* protocol_getName(Protocol* p);
    BOOL protocol_isEqual(Protocol* proto, Protocol* other);
    objc_method_description* protocol_copyMethodDescriptionList(Protocol* p, BOOL isRequiredMethod, BOOL isInstanceMethod, uint* outCount);
    objc_method_description protocol_getMethodDescription(Protocol* p, SEL aSel, BOOL isRequiredMethod, BOOL isInstanceMethod);
    objc_property_t* protocol_copyPropertyList(Protocol* protocol, uint* outCount);
    objc_property_t protocol_getProperty(Protocol* proto, const(char)* name, BOOL isRequiredProperty, BOOL isInstanceProperty);
    Protocol** protocol_copyProtocolList(Protocol* proto, uint* outCount);
    BOOL protocol_conformsToProtocol(Protocol* proto, Protocol* other);
}
    version (ModernAPI)
{
    const(char)* property_getName(objc_property_t property);
    const(char)* property_getAttributes(objc_property_t property);
}
}
alias objc_class* Class;
alias objc_method* Method;
alias objc_ivar* Ivar;
version (ModernAPI)
{
    alias objc_category* Category;
    alias objc_property* objc_property_t;
}
alias id function(id, SEL,...) IMP;
alias void* marg_list;
typedef objc_selector* SEL;
struct objc_method_description
{
    SEL name;
    char* types;
}
alias objc_object* id;
struct objc_super
{
    id receiver;
    Class super_class;
}
enum BOOL : byte
{
NO = 0,
YES = 1,
}
alias BOOL.YES YES;
alias BOOL.NO NO;
version (ModernAPI)
{
    alias uintptr_t objc_AssociationPolicy;
}
version (LegacyRuntime)
{
    pragma (objc_selectortarget)struct objc_class
{
    objc_class* isa;
    objc_class* super_class;
    const(char)* name;
    int version_ = 0;
    int info;
    int instance_size;
    objc_ivar_list* ivars;
    union
{
objc_method_list** methodLists;
objc_method_list* singleMethodList;
}
    objc_cache* cache;
    objc_protocol_list* protocols;
}

    enum : int
{
CLS_CLASS = 1,
CLS_META = 2,
CLS_INITIALIZED = 4,
CLS_POSING = 8,
CLS_MAPPED = 16,
CLS_GROW_CACHE = 32,
CLS_FLUSH_CACHE = 64,
CLS_NEED_BIND = 128,
CLS_METHOD_ARRAY = 256,
}
    struct objc_method
{
    SEL method_name;
    const(char)* method_types;
    IMP method_imp;
}
    struct objc_ivar
{
    const(char)* ivar_name;
    const(char)* ivar_type;
    int ivar_offset;
}
    struct objc_category;
    struct objc_property;
    pragma (objc_selectortarget)struct objc_object
{
    Class isa;
}

    struct objc_ivar_list
{
    int ivar_count;
    objc_ivar[0] ivar_list;
}
    struct objc_method_list
{
    void* obsolete;
    int method_count;
    objc_method[0] method_list;
}
    struct objc_cache
{
    uint mask;
    uint occupied;
    Method[0] buckets;
}
    struct objc_protocol_list
{
    objc_protocol_list* next;
    int count;
    Protocol*[0] list;
}
}
else
{
    pragma (objc_selectortarget)struct objc_class;

    struct objc_method;
    struct objc_ivar;
    struct objc_category;
    struct objc_property;
    pragma (objc_selectortarget)struct objc_object;

}
pragma (objc_isselector)struct objc_selector
{
}

version (LegacyRuntime)
{
    version (ModernAPI)
{
}
else
{
    Class object_getClass(id object)
{
return object.isa;
}
    Class class_getSuperclass(Class cls)
{
return cls.super_class;
}
}
}
